
import Queue

from trafficsignal.view.GuiPart import *
from trafficsignal.model.NeuralModel import *
from trafficsignal.model.ObjectModel import *

class Controller:

    def __init__(self, master):

        self.master = master
        self.queue = Queue.Queue()
        self.gui = GuiPart(master, self.queue, self)

    def runSimulation(self, selection):

        if selection == 1:
            self.model = ObjectModel(self.queue)
            print("Object model selected")
        elif selection == 2:
            self.model = NeuralModel(self.queue)
            print("Neural model selected")

        self.model.start()
        self.periodicCall()

    # so from the model implementation we have a callback to the gui to tell it to check if this
    # model has published an update ... so this sort of replaces a 'notification' design of an
    # observer pattern with a polling design akin to publish/subscribe

    def periodicCall(self):
        """
        Check every so many ms if there is something new in the queue.
        """
        self.gui.processIncoming()

        '''
        if not self.running:
            # This is the brutal stop of the system. You may want to do
            # some cleanup before actually shutting it down.
            import sys
            sys.exit(1)
        '''

        self.master.after(100, self.periodicCall)

