from Tkinter import *
from PIL import Image
from PIL import ImageTk

import os
import Queue

from trafficsignal.controller.EnumStates import *

# the main gui class

class GuiPart:

    def __init__(self, master, queue, contrl):

        self.queue = queue

        self.controller = contrl

        frame = Frame(master)

        image_path = os.path.join(os.getcwd(), 'images')
		
        red_file = os.path.join(image_path, 'red.gif')
        red_image = Image.open(red_file)
        self.red_light = ImageTk.PhotoImage(red_image)
        self.red_label = Label(image=self.red_light)

        amber_file = os.path.join(image_path, 'amber.gif')
        amber_image = Image.open(amber_file)
        self.amber_light = ImageTk.PhotoImage(amber_image)
        self.amber_label = Label(image=self.amber_light)

        green_file = os.path.join(image_path, 'green.gif')
        green_image = Image.open(green_file)
        self.green_light = ImageTk.PhotoImage(green_image)
        self.green_label = Label(image=self.green_light)

        black_file = os.path.join(image_path, 'black.gif')
        black_image = Image.open(black_file)
        self.black_light = ImageTk.PhotoImage(black_image)
        self.black_label = Label(image=self.black_light)

        self.model_selection = IntVar()

        self.model_selection.set(1)

        rb1 = Radiobutton(master, text="Object Model", variable=self.model_selection, value=1)
        rb2 = Radiobutton(master, text="Neuron Model", variable=self.model_selection, value=2)

        self.simulateBtn = Button(master, text="Run", command=self.runSimulation)

        self.red_label.pack()
        self.amber_label.pack()
        self.green_label.pack()

        rb1.pack()
        rb2.pack()

        self.simulateBtn.pack()	

        frame.pack()

        self.stopped_state()

    def runSimulation(self):
        select = self.model_selection.get()
        self.controller.runSimulation(select)


    def stopped_state(self):
        #print("configuring red")
        self.red_label.configure(image=self.red_light)
        self.amber_label.configure(image=self.black_light)
        self.green_label.configure(image=self.black_light)
        #print("done configuring red")

    def ready_state(self):
        #print("configuring amber and red")
        self.red_label.configure(image=self.red_light)
        self.amber_label.configure(image=self.amber_light)
        self.green_label.configure(image=self.black_light)
        #print("done configuring amber and red")

    def go_state(self):
        #print("configuring green")
        self.red_label.configure(image=self.black_light)
        self.amber_label.configure(image=self.black_light)
        self.green_label.configure(image=self.green_light)
        #print("done configuring green")

    def stopping_state(self):
        #print("configuring amber")
        self.red_label.configure(image=self.black_light)
        self.amber_label.configure(image=self.amber_light)
        self.green_label.configure(image=self.black_light)
        #print("done configuring amber")

    def update_gui(self, state):
        print("Gui updating...")
        if state == EnumStates.STOP:
            self.stopped_state()
        if state == EnumStates.READY:          
            self.ready_state()
        if state == EnumStates.GO:
            self.go_state()
        if state == EnumStates.STOPPING:
            self.stopping_state()

    def processIncoming(self):
        """Handle all messages currently in the queue, if any."""
        while self.queue.qsize(  ):
            try:
                msg = self.queue.get(0)
                print msg
                self.update_gui(msg)
            except Queue.Empty:
                pass


